#! ruby -Ku
  # 複数回答と単一回答の分解的集計 (coding: utf-8)
require "rrx"
    ##
rpro = <<EOS
source("tjsf.r")
dtf <- read.csv("data03.csv", header=T, na.strings="")
dtf <- ma.refactor(dtf, 3:6, c(1,NA))
items <- c("χ2", "df", "p-value", "cramer")
keys <- c("statistic", "parameter", "p.value", "cramer")
for (i in 3:6) {
  xx <- sa1(dtf, 2, i)
  zz <- chisq.test(xx$tbl1)
  zz <- append.cramer(zz)
  zz$join <- join.tbl(xx$tbl2, xx$pct1, "%d(%.1f)")
  ww <- sapply(keys, function(k) zz[[k]])
  names(ww) <- items
  print(zz$join);  cat("\n")
  print(ww);  cat("\n")
  if (zz$p.value < 0.05) {
    cat("☆　調整済み残差\n")
    print(zz$stdres);  cat("\n")
  }
  cat("\n\n")
  robj(zz)
}
EOS
    ##
hs = Rrx.rexec(rpro)
puts "** Rプログラムの出力"
print hs[:sink]
printf("\n")
items = %w(χ2 df p-value cramer)
keys = %w(statistic parameter p.value cramer)
str = ""
Rrx.robj_each() do |kk, zz|
  str = str + Rrx.ary2str(zz["join"], ",") + "\n"
  ary = []
  keys.each {|key|  ary << sprintf("%g", zz[key])}
  str = str + Rrx.ary2str([items, ary], ",") + "\n"
  if zz["p.value"] < 0.05
    str = str + "☆ 調整済み残差\n"
    str = str + Rrx.ary2str(zz["stdres"], ",") + "\n"
  end
  str = str + "\n\n"
end
File.open("result.csv", "w") {|ff|  ff.write str}
puts "'result.csv' を書き出しました."
